untyped
global function autoGlitchPrecache
global function autoGlitchSettings

void function autoGlitchPrecache(){
    #if CLIENT
    AddCallback_EntitiesDidLoad(glitchLightSettings)
    #endif
}

void function autoGlitchSettings(){
    #if UI
        #if S2_PLAYER_HAS_MOD_SETTINGS_GLITCH_AUTO
            AddModTitle("S2.GlitchOverhaul Post Processing")
            AddModCategory("Post Processing")
            AddConVarSettingEnum("glitch_oh_bloom_scale", "Bloom Scale", ["0 (Off)", "1 (Base)", "2 (Recommended)", "3 (Very High)"])
            AddConVarSettingEnum("glitch_oh_fog", "Map Fog", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_cc_toggle", "Colour Correction", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_oil_spill", "Oil Spill Lighting", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_oil_spill_shimmer", "Oil Spill Shimmer", ["Off", "On"])
            AddConVarSetting("glitch_oh_oil_spill_shimmer_speed", "Oil Spill Shimmer Speed", "float")
        #endif

        #if S2_GLITCH_OH_CC && S2_GLITCH_OH_PRT && S2_GLITCH_OH_SKB
            printt("[S2.GOH] Player has the package properly installed.")
        #else
            thread installDiagInit()
        #endif
    #endif
}

#if UI

void function installDiagInit(){
    WaitFrame()
    installDiag()
}

void function installDiag(){
    DialogData errorPopUp
    errorPopUp.header = "IMPROPER INSTALLATION DETECTED"
    errorPopUp.message = "GlitchOverhaul may have been installed with a Mod Manager.\n\nIt has to be installed manually, please uninstall your current version and follow the instructions in the mod's description.\n\nIf this error persists after a proper installation, make sure you have all of the specified folders, delete enabledmods.json from \\Titanfall2\\R2Northstar and restart the game."
    errorPopUp.image = $"ui/menu/common/dialog_error"
    AddDialogButton(errorPopUp, "Exit", void function(){ ClientCommand("exit") })
    AddDialogButton(errorPopUp, "Reinstall", void function(){
        LaunchExternalWebBrowser("https://northstar.thunderstore.io/package/S2Mods/GlitchOverhaul/", WEBBROWSER_FLAG_FORCEEXTERNAL)
        installDiag()
    })
    OpenDialog(errorPopUp)
}

#endif

#if CLIENT

array<string> touchedConvars = [
    "mat_bloomscale",
    "mat_bloom_wide_amount",
    "mat_colcorrection_disableentities",
    "mat_sky_color",
    "fog_enableskybox",
    "mat_disable_bloom",
    "fog_enable",
    "mat_force_bloom",
    "mat_sun_scale",
    "mat_colorcorrection",
    "mat_envmap_scale"
]

void function glitchLightSettings(){
    if(GetMapName() == "mp_glitch")
        thread glitchAutoLightLoop()
    if(GetConVarString("oldMapName") == "mp_glitch"){
        foreach(cvar in touchedConvars)
            SetConVarToDefault(cvar)
    }
    SetConVarString("oldMapName", GetMapName())
}

void function glitchAutoLightLoop(){
    while(GetMapName() == "mp_glitch"){
        WaitFrame()
        switch(GetConVarInt("glitch_oh_bloom_scale")){
            case 0:
                SetConVarInt("mat_bloomscale", 0)
            break;
            case 1:
                SetConVarInt("mat_bloomscale", 1)
                SetConVarFloat("mat_bloom_wide_amount", 0.2)
            break;
            case 2:
                SetConVarInt("mat_bloomscale", 3)
                SetConVarFloat("mat_bloom_wide_amount", 0.4)
            break;
            case 3:
                SetConVarInt("mat_bloomscale", 5)
                SetConVarFloat("mat_bloom_wide_amount", 0.6)
            break;
            default:
                SetConVarInt("mat_bloomscale", 0)
                printt("[S2.GOH] What the fuck???")
            break;
        }
        SetMapSetting_FogEnabled(GetConVarInt("glitch_oh_fog") == 1)
        SetConVarInt("mat_colorcorrection", GetConVarInt("glitch_oh_cc_toggle"))
        SetConVarInt("mat_colcorrection_disableentities", 1)
        SetConVarFloat("mat_envmap_scale", 0.25)
        SetConVarInt("mat_sun_scale", 0)
        if(GetConVarInt("glitch_oh_oil_spill")){
            if(GetConVarInt("glitch_oh_oil_spill_shimmer")){
                float shimmerSpeed = GetConVarFloat("glitch_oh_oil_spill_shimmer_speed")
                float shimmerX = (-0.0730323 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 0/3) * PI * 8))))
                float shimmerY = (-0.572792 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 1/3) * PI * 4))))
                float shimmerZ = (-2.49963 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 2/3) * PI * 2))))
                SetConVarString("mat_sky_color", (shimmerX.tostring() + " " + shimmerY.tostring() + " " + shimmerZ.tostring()))
            }
            else
                SetConVarString("mat_sky_color", "-0.0730323 -0.572792 -2.49963")
        }
        else
            SetConVarString("mat_sky_color", "0.1 0.15 0.2")
    }
}

#endif