untyped
global function glitchParticlesPrecache
global function glitchParticlesSettings

#if CLIENT

bool dev = false

void function createPrintDev(var button){
    vector playerPos = GetLocalViewPlayer().GetOrigin()
    vector playerAngles = GetLocalViewPlayer().GetAngles()
    StartParticleEffectInWorld( GetParticleSystemIndex( $"P_glitch_custom_400_blue" ), playerPos, playerAngles)
    printt("\nPos:    " + playerPos.x + ", " + playerPos.y + ", " + playerPos.z + "\nAng:    " + playerAngles.x + ", " + playerAngles.y + ", " + playerAngles.z)
}

void function createPrintDevTrace(var button){
    entity player = GetLocalViewPlayer()
    vector playerAngles = player.GetAngles()
    vector forward = AnglesToForward(player.EyeAngles())
	TraceResults trace = TraceLine(player.EyePosition(), player.EyePosition() + (55555 * forward), null, TRACE_MASK_NPCSOLID ) 
    StartParticleEffectInWorld( GetParticleSystemIndex( $"P_glitch_custom_400_blue" ), trace.endPos, playerAngles)
    printt("\nPos:    " + trace.endPos.x + ", " + trace.endPos.y + ", " + trace.endPos.z + "\nAng:    " + playerAngles.x + ", " + playerAngles.y + ", " + playerAngles.z)
}

#endif

void function glitchParticlesSettings(){
    #if UI
        #if S2_PLAYER_HAS_MOD_SETTINGS_GLITCH_PART
            AddModTitle("S2.GlitchOverhaul Particles")
            AddModCategory("Particles Main")
            AddConVarSettingEnum("glitch_oh_p_blue", "Blue Streaks", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_p_orange", "Orange Streaks", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_p_white", "White Streaks", ["Off", "On"])
            AddModCategory("Particles Experimental")
            AddConVarSettingEnum("glitch_oh_p_trees", "Particle Pillars", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_p_fractal", "Dimentional Breaches", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_p_fractal_alpha", "Dimentional Breaches Image", ["Glitch", "Fractal"])
        #endif
    #endif
}

void function glitchParticlesPrecache(){
    #if CLIENT
    AddCallback_EntitiesDidLoad(glitchScriptParticles)
    PrecacheParticleSystem($"P_glitch_custom_400_mdl")
    PrecacheParticleSystem($"P_glitch_custom_400_blue")
    PrecacheParticleSystem($"P_glitch_custom_400_orange")
    PrecacheParticleSystem($"P_glitch_custom_400_white")
    PrecacheParticleSystem($"P_glitch_custom_200_white")
    PrecacheParticleSystem($"P_glitch_custom_100_white")
    PrecacheParticleSystem($"P_glitch_tree_glow_outer")
    PrecacheParticleSystem($"P_glitch_tree_glow_inside")
    PrecacheParticleSystem($"P_glitch_pink_tree")
    PrecacheParticleSystem($"P_fractal_skyboxes")
	PrecacheModel($"models/levels_terrain/mp_wargames/wargames_grid_square_glitch.mdl")
    PrecacheModel($"models/cstm_fractal_balls/fractal_skybox.mdl")
    if(dev){
        RegisterButtonPressedCallback(KEY_I, createPrintDev)
        RegisterButtonPressedCallback(KEY_P, createPrintDevTrace)
    }
    #endif
}

#if CLIENT

const vector v0 = Vector(0, 0, 0)
const vector v90 = Vector(0, 90, 0)
const int Sx = -192
const int Sy = 128

vector function mirrorPos(vector pos){
    return (Vector((-384)-pos.x, 256-pos.y, pos.z))
}

vector function mirrorAngY(vector ang){
    return (Vector(ang.x, ang.y + 180, ang.z))
}

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}

const array<array<vector> > streaksBlue = [
    [< -12753.3, 12847.2, 12800>, <0, -33, 0>],//esc menu
    [<24.9498, -888.166, 720.031>, v90],
    [<1010.5, -656.815, 912.031>, v0],
    [<2501.5, 1055.39, 1024.03>, v0],
    [<1778.19, 1512.07, 1024.03>, v90],
    [<1974.83, 1694.94, 1024.03>, v0],
    [<1603.63, -981.523, 632.031>, v0],
    [<2068.62, 2015.12, 480.031>, v0],
    [<1630.96, 158.48, 463.364>, <0, -105, 0>],
    [<2840.42, 481.579, 476.224>, <0, -115, 0>],
    [<1137.01, 2757.44, 632.031>, v0],
    [<3631.6, -381.119, 512.031>, v0],
    [<2822.96, -613.264, 632.031>, v90],
    [<3020.15, -409.247, 632.031>, v0],
    [<601.165, -53.8798, 912.031>, v0],
    [<858.739, 499.075, 944.031>, v0],
    [<697.731, 842.095, 944.031>, v0],
    [<2323.66, 2761.74, 632.031>, v0],
    [<3775.66, 2331.1, 688.031>, <0, 135, 0>],
    [<3492.53, 2607.35, 688.031>, <0, 135, 0>],
    [<256.816, 2705.61, 632.031>, v90],
    [<913.932, -405.542, 912.031>, v90],
    [<480.519, -1617.25, 632.031>, v0],
    [<281.851, -1802.93, 632.031>, v90]
]

const array<array<vector> > streaksWhite400 = [
    [<2879.54, 708.565, 435.141>, <0, -90, 90>],
    [<2879.97, 829.918, 291.895>, <0, -90, 90>],
    [<1260.14, 1663.97, 275.11>, <0, 0, 90>],
    [<2407.7, 1696.03, 596.161>, <0, 180, 90>],
    [<2260.54, 1696.03, 739.61>, <0, 180, 90>],
    [<200.704, -31.9688, 459.902>, <0, 180, 90>],
    [<299.818, -31.9688, 259.576>, <0, 180, 90>],
    [< -529.763, -31.9688, -380.293>, <0, 180, 90>],
    [< -130.666, -31.9688, -380.303>, <0, 180, 90>],
    [< 150.666, -31.9688, -380.303>, <0, 180, 90>],
    [< -250.666, -31.9688, -380.303>, <0, 180, 90>],
    [<322.594, -31.9688, -204.826>, <0, 180, 90>],
    [< -122.594, -31.9688, -204.826>, <0, 180, 90>],
    [< -522.594, -31.9688, -204.826>, <0, 180, 90>],
    [< -706.811, -31.9687, -204.236>, <0, 180, 90>],
    [< -306.811, -31.9687, -204.236>, <0, 180, 90>],
    [<106.811, -31.9687, -204.236>, <0, 180, 90>],
    [<2223.02, 1663.97, 484.096>, <0, 0, 90>],
    [<2363.02, 1663.97, 340.000>, <0, 0, 90>],
]

const array<array<vector> > streaksWhite200 = [
    [< -74.9225, -1583.97, 393.652>, < -135, 0, 0>],
    [<159.573, -64.0313, 367.895>, < -135, 0, 0>],
    [<2250.34, 1051.23, 658.754>, <0, 0, 90>],
    [<2134.34, 1991.97, 172.408>, <0, 0, 90>],
    [<2005.32, 1991.97, 314.965>, <0, 0, 90>],
    [<1972.97, 1663.97, 483.925>, <0, 0, 90>],
    [<2422.78, 1663.97, 484.116>, <0, 0, 90>],
    [<2112.97, 1663.97, 340.000>, <0, 0, 90>],
    [<2562.78, 1663.97, 340.000>, <0, 0, 90>],
    [<2337.09, 1997.51, 243.000>, < -135, 0, 0>],
    [<2745.58, 1667.51, 412.000>, < -135, 0, 0>]
]

const array<array<vector> > streaksWhite100 = [
    [<2254.68, 1051.56, 802.612>, <0, 0, 90>],
    [<1772.1, 1526.52, 660.495>, <0, -90, 90>]
]

const array<vector> pinkPillars = [
    /*
    <1377.31, 369.818, 650.033>,
    <643.833, 654.483, 1207.62>,
    <206.372, -263.683, 1222.34>,
    <735.412, -198.352, 1215.88>,
    <254.388, -716.806, 1020.269>,
    <148.924, -712.252, 1056.078>,
    <198.946, -1061.84, 1011.012>
    */
    <1574.94, 794.679, 316.031>,
    <2428.72, 1431.7, 128.031>
]

void function glitchScriptParticles(){
    if(GetMapName() == "mp_glitch"){
        bool blueStreaks = (GetConVarInt("glitch_oh_p_blue") == 1) ? true : false
        bool orangeStreaks = (GetConVarInt("glitch_oh_p_orange") == 1) ? true : false
        bool whiteStreaks = (GetConVarInt("glitch_oh_p_white") == 1) ? true : false
        bool treeStreaks = (GetConVarInt("glitch_oh_p_trees") == 1) ? true : false
        bool fractalParticles = (GetConVarInt("glitch_oh_p_fractal") == 1) ? true : false
        PrecacheParticleSystem($"P_glitch_custom_400_white")
        if(blueStreaks){
            foreach(pair in streaksBlue){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_400_blue"), pair[0], pair[1])
            }
        }
        if(orangeStreaks){
            foreach(pair in streaksBlue){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_400_orange"), mirrorPos(pair[0]), pair[1])
            }
        }
        if(whiteStreaks){
            foreach(pairWhite in streaksWhite400){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_400_white"), pairWhite[0], pairWhite[1])
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_400_white"), mirrorPos(pairWhite[0]), mirrorAngY(pairWhite[1]))
            }
            foreach(pairWhite200 in streaksWhite200){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_200_white"), pairWhite200[0], pairWhite200[1])
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_200_white"), mirrorPos(pairWhite200[0]), mirrorAngY(pairWhite200[1]))
            }
            foreach(pairWhite100 in streaksWhite100){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), pairWhite100[0], pairWhite100[1])
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), mirrorPos(pairWhite100[0]), mirrorAngY(pairWhite100[1]))
            }
            for(int i = 1; i < 7; i++){
                float Px = 2200.0 - 420 * cos(PI*i/14)
                float Py = 1455.0 - 410 * sin(PI*i/14)
                vector circleThingPosUp = Vector(Px, Py, 803.0)
                vector circleThingPosBottom = Vector(Px, Py, 658.0)
                vector circleThingAng = Vector(0.0, (i*90.0/7.0 - 90.0), 90.0)
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), circleThingPosUp, circleThingAng)
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), mirrorPos(circleThingPosUp), mirrorAngY(circleThingAng))
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), circleThingPosBottom, circleThingAng)
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_custom_100_white"), mirrorPos(circleThingPosBottom), mirrorAngY(circleThingAng))
            }
        }
        if(treeStreaks){
            foreach(pos in pinkPillars){
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_pink_tree"), pos, v0)
                StartParticleEffectInWorld(GetParticleSystemIndex($"P_glitch_pink_tree"), mirrorPos(pos), v0)
            }
        }
        if(fractalParticles)
            StartParticleEffectInWorld(GetParticleSystemIndex($"P_fractal_skyboxes"), < -192, 128, 3000>, v90)
        thread fractalUpdate()
    }
}

void function fractalUpdate(){
    while(GetMapName() == "mp_glitch"){
        WaitFrame()
        SetConVarInt("glitch_oh_p_fractal_alpha_2", ((GetConVarInt("glitch_oh_p_fractal_alpha") == 0) ? 1 : 0))
    }
}

#endif